diff -ruNp linux-2.6.23.16/kernel/module.c linux-2.6.23.16-cher1/kernel/module.c
--- linux-2.6.23.16/kernel/module.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/module.c	2008-02-12 11:21:39.000000000 +0300
@@ -660,6 +660,11 @@ sys_delete_module(const char __user *nam
 	char name[MODULE_NAME_LEN];
 	int ret, forced = 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
 
@@ -1978,6 +1983,11 @@ sys_init_module(void __user *umod,
 	struct module *mod;
 	int ret = 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/* Must have permission */
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
@@ -2474,3 +2484,9 @@ EXPORT_SYMBOL(module_remove_driver);
 void struct_module(struct module *mod) { return; }
 EXPORT_SYMBOL(struct_module);
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/posix-cpu-timers.c linux-2.6.23.16-cher1/kernel/posix-cpu-timers.c
--- linux-2.6.23.16/kernel/posix-cpu-timers.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/posix-cpu-timers.c	2008-02-12 11:21:39.000000000 +0300
@@ -649,6 +649,10 @@ static void arm_timer(struct k_itimer *t
 				    cputime_lt(p->signal->it_prof_expires,
 					       timer->it.cpu.expires.cpu))
 					break;
+				i = p->signal->rlim[RLIMIT_MCPU].rlim_cur;
+				if (i != RLIM_INFINITY &&
+				    i <= cputime_to_msecs(timer->it.cpu.expires.cpu))
+					break;
 				i = p->signal->rlim[RLIMIT_CPU].rlim_cur;
 				if (i != RLIM_INFINITY &&
 				    i <= cputime_to_secs(timer->it.cpu.expires.cpu))
@@ -1034,6 +1038,7 @@ static void check_process_timers(struct 
 	if (list_empty(&timers[CPUCLOCK_PROF]) &&
 	    cputime_eq(sig->it_prof_expires, cputime_zero) &&
 	    sig->rlim[RLIMIT_CPU].rlim_cur == RLIM_INFINITY &&
+	    sig->rlim[RLIMIT_MCPU].rlim_cur == RLIM_INFINITY &&
 	    list_empty(&timers[CPUCLOCK_VIRT]) &&
 	    cputime_eq(sig->it_virt_expires, cputime_zero) &&
 	    list_empty(&timers[CPUCLOCK_SCHED]))
@@ -1160,6 +1165,33 @@ static void check_process_timers(struct 
 			prof_expires = x;
 		}
 	}
+	if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+		unsigned long psecs = cputime_to_msecs(ptime);
+		cputime_t x;
+		if (psecs >= sig->rlim[RLIMIT_MCPU].rlim_max) {
+			/*
+			 * At the hard limit, we just die.
+			 * No need to calculate anything else now.
+			 */
+			__group_send_sig_info(SIGKILL, SEND_SIG_PRIV, tsk);
+			return;
+		}
+		if (psecs >= sig->rlim[RLIMIT_MCPU].rlim_cur) {
+			/*
+			 * At the soft limit, send a SIGXCPU every second.
+			 */
+			__group_send_sig_info(SIGXCPU, SEND_SIG_PRIV, tsk);
+			if (sig->rlim[RLIMIT_MCPU].rlim_cur
+			    < sig->rlim[RLIMIT_MCPU].rlim_max) {
+				sig->rlim[RLIMIT_MCPU].rlim_cur++;
+			}
+		}
+		x = msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+		if (cputime_eq(prof_expires, cputime_zero) ||
+		    cputime_lt(x, prof_expires)) {
+			prof_expires = x;
+		}
+	}
 
 	if (!cputime_eq(prof_expires, cputime_zero) ||
 	    !cputime_eq(virt_expires, cputime_zero) ||
@@ -1392,6 +1424,9 @@ void set_process_cpu_timer(struct task_s
 		if (tsk->signal->rlim[RLIMIT_CPU].rlim_cur
 		    < cputime_to_secs(*newval))
 			return;
+		if (tsk->signal->rlim[RLIMIT_MCPU].rlim_cur
+		    < cputime_to_msecs(*newval))
+			return;
 	}
 
 	/*
diff -ruNp linux-2.6.23.16/kernel/posix-timers.c linux-2.6.23.16-cher1/kernel/posix-timers.c
--- linux-2.6.23.16/kernel/posix-timers.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/posix-timers.c	2008-02-12 11:21:39.000000000 +0300
@@ -471,6 +471,9 @@ sys_timer_create(const clockid_t which_c
 	sigevent_t event;
 	int it_id_set = IT_ID_NOT_SET;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -684,6 +687,9 @@ sys_timer_gettime(timer_t timer_id, stru
 	struct itimerspec cur_setting;
 	unsigned long flags;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -714,6 +720,9 @@ sys_timer_getoverrun(timer_t timer_id)
 	int overrun;
 	long flags;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -787,6 +796,9 @@ sys_timer_settime(timer_t timer_id, int 
 	long flag;
 	struct itimerspec *rtn = old_setting ? &old_spec : NULL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (!new_setting)
 		return -EINVAL;
 
@@ -838,6 +850,9 @@ sys_timer_delete(timer_t timer_id)
 	struct k_itimer *timer;
 	long flags;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 retry_delete:
 	timer = lock_timer(timer_id, &flags);
 	if (!timer)
@@ -930,6 +945,9 @@ asmlinkage long sys_clock_settime(const 
 {
 	struct timespec new_tp;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
@@ -944,6 +962,9 @@ sys_clock_gettime(const clockid_t which_
 	struct timespec kernel_tp;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	error = CLOCK_DISPATCH(which_clock, clock_get,
@@ -961,6 +982,9 @@ sys_clock_getres(const clockid_t which_c
 	struct timespec rtn_tp;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -992,6 +1016,9 @@ sys_clock_nanosleep(const clockid_t whic
 {
 	struct timespec t;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1025,3 +1052,9 @@ clock_nanosleep_restart(struct restart_b
 	return CLOCK_DISPATCH(which_clock, nsleep_restart,
 			      (restart_block));
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/printk.c linux-2.6.23.16-cher1/kernel/printk.c
--- linux-2.6.23.16/kernel/printk.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/printk.c	2008-02-12 11:21:39.000000000 +0300
@@ -314,6 +314,9 @@ out:
 
 asmlinkage long sys_syslog(int type, char __user *buf, int len)
 {
+  if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return do_syslog(type, buf, len);
 }
 
diff -ruNp linux-2.6.23.16/kernel/ptrace.c linux-2.6.23.16-cher1/kernel/ptrace.c
--- linux-2.6.23.16/kernel/ptrace.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/ptrace.c	2008-02-12 11:21:39.000000000 +0300
@@ -456,6 +456,20 @@ asmlinkage long sys_ptrace(long request,
 	struct task_struct *child;
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
+        if (request == PTRACE_MEMLIMIT) {
+                current->sbox_flags |= SBOX_MEMLIMITON;
+                return 0;
+        }
+        if (request == PTRACE_NO_SYSCALLS) {
+                current->sbox_flags |= SBOX_NO_SYSCALLS;
+                return 0;
+        }
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
@@ -510,3 +524,9 @@ int generic_ptrace_pokedata(struct task_
 	copied = access_process_vm(tsk, addr, &data, sizeof(data), 1);
 	return (copied == sizeof(data)) ? 0 : -EIO;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/sched.c linux-2.6.23.16-cher1/kernel/sched.c
--- linux-2.6.23.16/kernel/sched.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/sched.c	2008-02-12 11:21:39.000000000 +0300
@@ -4063,6 +4063,9 @@ asmlinkage long sys_nice(int increment)
 {
 	long nice, retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/*
 	 * Setpriority might change our priority at the same moment.
 	 * We don't have to worry. Conceptually one call occurs first
@@ -4319,6 +4322,9 @@ do_sched_setscheduler(pid_t pid, int pol
 asmlinkage long sys_sched_setscheduler(pid_t pid, int policy,
 				       struct sched_param __user *param)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* negative values for policy are not valid */
 	if (policy < 0)
 		return -EINVAL;
@@ -4333,6 +4339,9 @@ asmlinkage long sys_sched_setscheduler(p
  */
 asmlinkage long sys_sched_setparam(pid_t pid, struct sched_param __user *param)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return do_sched_setscheduler(pid, -1, param);
 }
 
@@ -4345,6 +4354,9 @@ asmlinkage long sys_sched_getscheduler(p
 	struct task_struct *p;
 	int retval = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (pid < 0)
 		goto out_nounlock;
 
@@ -4373,6 +4385,9 @@ asmlinkage long sys_sched_getparam(pid_t
 	struct task_struct *p;
 	int retval = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (!param || pid < 0)
 		goto out_nounlock;
 
@@ -4468,6 +4483,9 @@ asmlinkage long sys_sched_setaffinity(pi
 	cpumask_t new_mask;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	retval = get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -4531,6 +4549,9 @@ asmlinkage long sys_sched_getaffinity(pi
 	int ret;
 	cpumask_t mask;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (len < sizeof(cpumask_t))
 		return -EINVAL;
 
@@ -6739,3 +6760,9 @@ void set_curr_task(int cpu, struct task_
 }
 
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/signal.c linux-2.6.23.16-cher1/kernel/signal.c
--- linux-2.6.23.16/kernel/signal.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/signal.c	2008-02-12 11:21:39.000000000 +0300
@@ -1149,6 +1149,27 @@ static int kill_something_info(int sig, 
 {
 	int ret;
 	rcu_read_lock();
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                if (pid != current->pid) {
+                        rcu_read_unlock();
+                        current->sbox_flags |= SBOX_WAS_SECURITY;
+                        return -EPERM;
+                } else if (!pid) {
+                        pid = current->pid;
+                } else if (pid == -1) {
+                        rcu_read_unlock();
+                        current->sbox_flags |= SBOX_WAS_SECURITY;
+                        return -EPERM;
+                } else if (pid < 0 && current->signal->pgrp != -pid) {
+                        rcu_read_unlock();
+                        current->sbox_flags |= SBOX_WAS_SECURITY;
+                        return -EPERM;
+                } else if (pid < 0) {
+                        pid = current->pid;
+                }
+        }
+
 	if (!pid) {
 		ret = kill_pgrp_info(sig, info, task_pgrp(current));
 	} else if (pid == -1) {
@@ -1989,6 +2010,9 @@ sys_rt_sigprocmask(int how, sigset_t __u
 	int error = -EINVAL;
 	sigset_t old_set, new_set;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2046,6 +2070,9 @@ out:
 asmlinkage long
 sys_rt_sigpending(sigset_t __user *set, size_t sigsetsize)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return do_sigpending(set, sigsetsize);
 }
 
@@ -2127,6 +2154,9 @@ sys_rt_sigtimedwait(const sigset_t __use
 	siginfo_t info;
 	long timeout = 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2251,6 +2281,9 @@ static int do_tkill(int tgid, int pid, i
  */
 asmlinkage long sys_tgkill(int tgid, int pid, int sig)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0 || tgid <= 0)
 		return -EINVAL;
@@ -2264,6 +2297,9 @@ asmlinkage long sys_tgkill(int tgid, int
 asmlinkage long
 sys_tkill(int pid, int sig)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0)
 		return -EINVAL;
@@ -2276,6 +2312,9 @@ sys_rt_sigqueueinfo(int pid, int sig, si
 {
 	siginfo_t info;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
 		return -EFAULT;
 
@@ -2414,6 +2453,9 @@ out:
 asmlinkage long
 sys_sigpending(old_sigset_t __user *set)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return do_sigpending(set, sizeof(*set));
 }
 
@@ -2429,6 +2471,9 @@ sys_sigprocmask(int how, old_sigset_t __
 	int error;
 	old_sigset_t old_set, new_set;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (set) {
 		error = -EFAULT;
 		if (copy_from_user(&new_set, set, sizeof(*set)))
@@ -2520,6 +2565,9 @@ sys_ssetmask(int newmask)
 {
 	int old;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	spin_lock_irq(&current->sighand->siglock);
 	old = current->blocked.sig[0];
 
@@ -2557,6 +2605,9 @@ sys_signal(int sig, __sighandler_t handl
 asmlinkage long
 sys_pause(void)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	current->state = TASK_INTERRUPTIBLE;
 	schedule();
 	return -ERESTARTNOHAND;
@@ -2569,6 +2620,9 @@ asmlinkage long sys_rt_sigsuspend(sigset
 {
 	sigset_t newset;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2599,3 +2653,9 @@ void __init signals_init(void)
 {
 	sigqueue_cachep = KMEM_CACHE(sigqueue, SLAB_PANIC);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/sys.c linux-2.6.23.16-cher1/kernel/sys.c
--- linux-2.6.23.16/kernel/sys.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/sys.c	2008-02-12 11:21:39.000000000 +0300
@@ -670,6 +670,9 @@ asmlinkage long sys_setpriority(int whic
 	int error = -EINVAL;
 	struct pid *pgrp;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		goto out;
 
@@ -734,6 +737,9 @@ asmlinkage long sys_getpriority(int whic
 	long niceval, retval = -ESRCH;
 	struct pid *pgrp;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		return -EINVAL;
 
@@ -897,6 +903,11 @@ asmlinkage long sys_reboot(int magic1, i
 {
 	char buffer[256];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -1019,6 +1030,11 @@ asmlinkage long sys_setregid(gid_t rgid,
 	int new_egid = old_egid;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(rgid, egid, (gid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -1065,6 +1081,11 @@ asmlinkage long sys_setgid(gid_t gid)
 	int old_egid = current->egid;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -1135,6 +1156,11 @@ asmlinkage long sys_setreuid(uid_t ruid,
 	int old_ruid, old_euid, old_suid, new_ruid, new_euid;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(ruid, euid, (uid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -1198,6 +1224,11 @@ asmlinkage long sys_setuid(uid_t uid)
 	int old_ruid, old_suid, new_suid;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -1238,6 +1269,11 @@ asmlinkage long sys_setresuid(uid_t ruid
 	int old_suid = current->suid;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(ruid, euid, suid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -1292,6 +1328,11 @@ asmlinkage long sys_setresgid(gid_t rgid
 {
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(rgid, egid, sgid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -1347,6 +1388,11 @@ asmlinkage long sys_setfsuid(uid_t uid)
 {
 	int old_fsuid;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	old_fsuid = current->fsuid;
 	if (security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_FS))
 		return old_fsuid;
@@ -1376,6 +1422,11 @@ asmlinkage long sys_setfsgid(gid_t gid)
 {
 	int old_fsgid;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	old_fsgid = current->fsgid;
 	if (security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_FS))
 		return old_fsgid;
@@ -1450,6 +1501,9 @@ asmlinkage long sys_setpgid(pid_t pid, p
 	struct task_struct *group_leader = current->group_leader;
 	int err = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (!pid)
 		pid = group_leader->pid;
 	if (!pgid)
@@ -1515,6 +1569,9 @@ out:
 
 asmlinkage long sys_getpgid(pid_t pid)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS) && pid != current->pid)
+                return -EPERM;
+
 	if (!pid)
 		return process_group(current);
 	else {
@@ -1547,6 +1604,9 @@ asmlinkage long sys_getpgrp(void)
 
 asmlinkage long sys_getsid(pid_t pid)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS) && pid != current->pid)
+                return -EPERM;
+
 	if (!pid)
 		return process_session(current);
 	else {
@@ -1573,6 +1633,9 @@ asmlinkage long sys_setsid(void)
 	pid_t session;
 	int err = -EPERM;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	write_lock_irq(&tasklist_lock);
 
 	/* Fail if I am already a session leader */
@@ -1816,6 +1879,11 @@ asmlinkage long sys_setgroups(int gidset
 	struct group_info *group_info;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
@@ -1879,6 +1947,11 @@ asmlinkage long sys_sethostname(char __u
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1924,6 +1997,11 @@ asmlinkage long sys_setdomainname(char _
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1981,8 +2059,12 @@ asmlinkage long sys_setrlimit(unsigned i
 {
 	struct rlimit new_rlim, *old_rlim;
 	unsigned long it_prof_secs;
+	unsigned long it_prof_msecs;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (resource >= RLIM_NLIMITS)
 		return -EINVAL;
 	if (copy_from_user(&new_rlim, rlim, sizeof(*rlim)))
@@ -2009,11 +2091,34 @@ asmlinkage long sys_setrlimit(unsigned i
 		 */
 		new_rlim.rlim_cur = 1;
 	}
+        if (resource == RLIMIT_MCPU && new_rlim.rlim_cur == 0) {
+                new_rlim.rlim_cur = 1;
+        }
 
 	task_lock(current->group_leader);
 	*old_rlim = new_rlim;
 	task_unlock(current->group_leader);
 
+        if (resource == RLIMIT_MCPU) {
+                if (new_rlim.rlim_cur == RLIM_INFINITY)
+                        goto out;
+                it_prof_msecs =
+			cputime_to_msecs(current->signal->it_prof_expires);
+                if (it_prof_msecs == 0 || new_rlim.rlim_cur <= it_prof_msecs) {
+                        unsigned long rlim_cur = new_rlim.rlim_cur;
+                        cputime_t cputime;
+
+                        cputime = msecs_to_cputime(rlim_cur);
+                        read_lock(&tasklist_lock);
+                        spin_lock_irq(&current->sighand->siglock);
+                        set_process_cpu_timer(current, CPUCLOCK_PROF, &cputime,
+				NULL);
+                        spin_unlock_irq(&current->sighand->siglock);
+                        read_unlock(&tasklist_lock);
+                }
+                goto out;
+        }
+
 	if (resource != RLIMIT_CPU)
 		goto out;
 
@@ -2155,6 +2260,9 @@ asmlinkage long sys_getrusage(int who, s
 
 asmlinkage long sys_umask(int mask)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return current->fs->umask;
+
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
 	return mask;
 }
@@ -2164,6 +2272,9 @@ asmlinkage long sys_prctl(int option, un
 {
 	long error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	error = security_task_prctl(option, arg2, arg3, arg4, arg5);
 	if (error)
 		return error;
@@ -2275,6 +2386,10 @@ asmlinkage long sys_getcpu(unsigned __us
 {
 	int err = 0;
 	int cpu = raw_smp_processor_id();
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (cpup)
 		err |= put_user(cpu, cpup);
 	if (nodep)
@@ -2357,3 +2472,9 @@ int orderly_poweroff(bool force)
 	return ret;
 }
 EXPORT_SYMBOL_GPL(orderly_poweroff);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/sysctl.c linux-2.6.23.16-cher1/kernel/sysctl.c
--- linux-2.6.23.16/kernel/sysctl.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/sysctl.c	2008-02-12 11:21:39.000000000 +0300
@@ -2524,6 +2524,11 @@ asmlinkage long sys_sysctl(struct __sysc
 	int name[CTL_MAXNAME];
 	int i;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/* Read in the sysctl name for better debug message logging */
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
diff -ruNp linux-2.6.23.16/kernel/time.c linux-2.6.23.16-cher1/kernel/time.c
--- linux-2.6.23.16/kernel/time.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/time.c	2008-02-12 11:21:39.000000000 +0300
@@ -82,6 +82,11 @@ asmlinkage long sys_stime(time_t __user 
 	struct timespec tv;
 	int err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -186,6 +191,11 @@ asmlinkage long sys_settimeofday(struct 
 	struct timespec	new_ts;
 	struct timezone new_tz;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (tv) {
 		if (copy_from_user(&user_tv, tv, sizeof(*tv)))
 			return -EFAULT;
@@ -205,6 +215,11 @@ asmlinkage long sys_adjtimex(struct time
 	struct timex txc;		/* Local copy of parameter */
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/* Copy the user data space into the kernel copy
 	 * structure. But bear in mind that the structures
 	 * may change
@@ -653,3 +668,9 @@ EXPORT_SYMBOL(get_jiffies_64);
 #endif
 
 EXPORT_SYMBOL(jiffies);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/timer.c linux-2.6.23.16-cher1/kernel/timer.c
--- linux-2.6.23.16/kernel/timer.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/timer.c	2008-02-12 11:21:39.000000000 +0300
@@ -1193,6 +1193,9 @@ asmlinkage long sys_sysinfo(struct sysin
 {
 	struct sysinfo val;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	do_sysinfo(&val);
 
 	if (copy_to_user(info, &val, sizeof(struct sysinfo)))
@@ -1377,3 +1380,9 @@ unsigned long msleep_interruptible(unsig
 }
 
 EXPORT_SYMBOL(msleep_interruptible);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/uid16.c linux-2.6.23.16-cher1/kernel/uid16.c
--- linux-2.6.23.16/kernel/uid16.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/uid16.c	2008-02-12 11:21:39.000000000 +0300
@@ -188,6 +188,11 @@ asmlinkage long sys_setgroups16(int gids
 	struct group_info *group_info;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
@@ -227,3 +232,9 @@ asmlinkage long sys_getegid16(void)
 {
 	return high2lowgid(current->egid);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/Makefile linux-2.6.23.16-cher1/Makefile
--- linux-2.6.23.16/Makefile	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/Makefile	2008-02-12 11:22:01.000000000 +0300
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 6
 SUBLEVEL = 23
-EXTRAVERSION = .16
+EXTRAVERSION = .16-cher1
 NAME = Arr Matey! A Hairy Bilge Rat!
 
 # *DOCUMENTATION*
diff -ruNp linux-2.6.23.16/mm/filemap.c linux-2.6.23.16-cher1/mm/filemap.c
--- linux-2.6.23.16/mm/filemap.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/filemap.c	2008-02-12 11:21:39.000000000 +0300
@@ -1235,6 +1235,9 @@ asmlinkage ssize_t sys_readahead(int fd,
 	ssize_t ret;
 	struct file *file;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = -EBADF;
 	file = fget(fd);
 	if (file) {
diff -ruNp linux-2.6.23.16/mm/madvise.c linux-2.6.23.16-cher1/mm/madvise.c
--- linux-2.6.23.16/mm/madvise.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/madvise.c	2008-02-12 11:21:39.000000000 +0300
@@ -290,6 +290,9 @@ asmlinkage long sys_madvise(unsigned lon
 	int write;
 	size_t len;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	write = madvise_need_mmap_write(behavior);
 	if (write)
 		down_write(&current->mm->mmap_sem);
diff -ruNp linux-2.6.23.16/mm/mempolicy.c linux-2.6.23.16-cher1/mm/mempolicy.c
--- linux-2.6.23.16/mm/mempolicy.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mempolicy.c	2008-02-12 11:21:39.000000000 +0300
@@ -878,6 +878,9 @@ asmlinkage long sys_mbind(unsigned long 
 	nodemask_t nodes;
 	int err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	err = get_nodes(&nodes, nmask, maxnode);
 	if (err)
 		return err;
@@ -895,6 +898,9 @@ asmlinkage long sys_set_mempolicy(int mo
 	int err;
 	nodemask_t nodes;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (mode < 0 || mode > MPOL_MAX)
 		return -EINVAL;
 	err = get_nodes(&nodes, nmask, maxnode);
@@ -914,6 +920,9 @@ asmlinkage long sys_migrate_pages(pid_t 
 	nodemask_t task_nodes;
 	int err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	err = get_nodes(&old, old_nodes, maxnode);
 	if (err)
 		return err;
@@ -981,6 +990,9 @@ asmlinkage long sys_get_mempolicy(int __
 	int err, pval;
 	nodemask_t nodes;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (nmask != NULL && maxnode < MAX_NUMNODES)
 		return -EINVAL;
 
@@ -1010,6 +1022,9 @@ asmlinkage long compat_sys_get_mempolicy
 	unsigned long nr_bits, alloc_size;
 	DECLARE_BITMAP(bm, MAX_NUMNODES);
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	nr_bits = min_t(unsigned long, maxnode-1, MAX_NUMNODES);
 	alloc_size = ALIGN(nr_bits, BITS_PER_LONG) / 8;
 
@@ -1036,6 +1051,9 @@ asmlinkage long compat_sys_set_mempolicy
 	unsigned long nr_bits, alloc_size;
 	DECLARE_BITMAP(bm, MAX_NUMNODES);
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	nr_bits = min_t(unsigned long, maxnode-1, MAX_NUMNODES);
 	alloc_size = ALIGN(nr_bits, BITS_PER_LONG) / 8;
 
@@ -1060,6 +1078,9 @@ asmlinkage long compat_sys_mbind(compat_
 	unsigned long nr_bits, alloc_size;
 	nodemask_t bm;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	nr_bits = min_t(unsigned long, maxnode-1, MAX_NUMNODES);
 	alloc_size = ALIGN(nr_bits, BITS_PER_LONG) / 8;
 
@@ -2002,3 +2023,8 @@ out:
 	return 0;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/mm/migrate.c linux-2.6.23.16-cher1/mm/migrate.c
--- linux-2.6.23.16/mm/migrate.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/migrate.c	2008-02-12 11:21:39.000000000 +0300
@@ -915,6 +915,9 @@ asmlinkage long sys_move_pages(pid_t pid
 	struct mm_struct *mm;
 	struct page_to_node *pm = NULL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* Check flags */
 	if (flags & ~(MPOL_MF_MOVE|MPOL_MF_MOVE_ALL))
 		return -EINVAL;
diff -ruNp linux-2.6.23.16/mm/mincore.c linux-2.6.23.16-cher1/mm/mincore.c
--- linux-2.6.23.16/mm/mincore.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mincore.c	2008-02-12 11:21:39.000000000 +0300
@@ -184,6 +184,9 @@ asmlinkage long sys_mincore(unsigned lon
 	unsigned long pages;
 	unsigned char *tmp;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* Check the start address: needs to be page-aligned.. */
  	if (start & ~PAGE_CACHE_MASK)
 		return -EINVAL;
